#version 430 core

layout (triangles) in;
layout (triangle_strip, max_vertices = 3) out;

// Input variables
in VertexData
{
	vec3 normal_ws;		// Normal in world space
	vec3 position_ws;	// Position in world space
	vec2 tex_coord;
	int layer;
} inData[3];

// Output variables
out VertexData
{
	vec3 normal_ws;		// Normal in world space
	vec3 position_ws;	// Position in world space
	vec2 tex_coord;
} outData;

//-----------------------------------------------------------------------

void main()
{
	// Task 4: Pass the data from vertex shader (tex_coord, position_ws, normal_ws, and gl_Position), and set gl_Layer
	//		Hint: gl_Position position computed in vertex shader is accessible via gl_in[v].gl_Position
	for (int v = 0; v < 3; v++)
	{
		// Pass the data of the vertex
		outData.tex_coord = inData[v].tex_coord;
		outData.position_ws = inData[v].position_ws;
		outData.normal_ws = inData[v].normal_ws;

		// Set gl_Layer from input data
		gl_Layer = inData[v].layer;
		
		// Set the gl_Position (from the data from the vertex shader)
		gl_Position = gl_in[v].gl_Position;
		
		// Emit the vertex
		EmitVertex();
	}
}
